<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Home - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="file.html">file</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="file.html#.readDir">readDir</a></li><li data-type='method' style='display: none;'><a href="file.html#.getFileTime">getFileTime</a></li><li data-type='method' style='display: none;'><a href="file.html#.path">path</a></li><li data-type='method' style='display: none;'><a href="file.html#.exists">exists</a></li><li data-type='method' style='display: none;'><a href="file.html#.load">load</a></li><li data-type='method' style='display: none;'><a href="file.html#.save">save</a></li><li data-type='method' style='display: none;'><a href="file.html#.gnuplot">gnuplot</a></li></ul></li><li><a href="http.html">http</a></li><li><a href="python.html">python</a></li><li><a href="regex.html">regex</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="regex.html#.regexMatch">regexMatch</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexIndexes">regexIndexes</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexReplace">regexReplace</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexSplit">regexSplit</a></li></ul></li><li><a href="stats.html">stats</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="stats.html#.random">random</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStatValue">getStatValue</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getDivergence">getDivergence</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotHistogram">plotHistogram</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatCurve">plotStatCurve</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatBoxes">plotStatBoxes</a></li></ul></li><li><a href="std.html">std</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="std.html#.echo">echo</a></li><li data-type='method' style='display: none;'><a href="std.html#.alert">alert</a></li><li data-type='method' style='display: none;'><a href="std.html#.argv">argv</a></li><li data-type='method' style='display: none;'><a href="std.html#.system">system</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li></ul></li><li><a href="time.html">time</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="time.html#.sleep">sleep</a></li><li data-type='method' style='display: none;'><a href="time.html#.now">now</a></li><li data-type='method' style='display: none;'><a href="time.html#.nowISO">nowISO</a></li></ul></li></ul>
    
</nav>

<div id="main">
    

    



    


    <section class="package">
        <h3> </h3>		
    </section>









    



    <section class="readme usertext">
        <article><h1>aidesys</h1>
<p>Basic system C/C++ interface routines to ease multi-language middleware integration</p>
<div style='float:right;margin-left:20px'><a target=_blank' href='https://line.gitlabpages.inria.fr/aide-group/aide/index.html'><img alt='AIDE API docs' src='https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png'/></a></div>
<h2>Presentation</h2>
<p>This factory encapsulates basic system interface.</p>
<ul>
<li>
<p>Functionalities includes:</p>
<ul>
<li>Standard <code>std</code> functions for code string formatting and debugging :
<ul>
<li><code>aidesys::echo</code> To format a string à-la <code>sprintf</code>s</li>
<li><code>aidesys::alert</code> To verify an assertion and send a warning or a fatal error with trace.</li>
<li><code>aidesys::argv</code> To get program line arguments.</li>
<li><code>aidesys::system</code> To execute commands at the OS level.</li>
</ul>
</li>
<li>Simple files <code>file</code> interface:
<ul>
<li><code>aidesys::readDir</code> To returns the contents of a directory</li>
<li><code>aidesys::getFileTime</code> and <code>aidesys::exists</code> To get the last file modification time and check if a file exists.</li>
<li><code>aidesys::load</code> and <code>aidesys::save</code> To load/save textual files.</li>
</ul>
</li>
<li>Time <code>time</code> management:
<ul>
<li><code>aidesys::sleep</code> To introduce a delay.</li>
<li><code>aidesys::now</code> To measure the real or CPU relative or absolute time.</li>
<li><code>aidesys::nowISO</code> To get the present date and time in a standard format.</li>
</ul>
</li>
<li>Regular expression (regex) and string manipulation:
<ul>
<li><code>aidesys::regexMatch</code> and <code>aidesys::regexReplace</code> To match and replace strings.</li>
<li><code>aidesys::regexIndexes</code> To get all occurrences of a regex in a string.</li>
<li><code>aidesys::stringSplit</code> To split a string according to a regex.</li>
</ul>
</li>
<li>HTTP interface via the <code>aidesys::http</code> function.</li>
<li>Python online interface via the <code>aidesys::python</code> function.</li>
<li>Pseudo-random number generation via the <code>aidesys::random</code> function.</li>
</ul>
</li>
<li>
<p>The implementation consists mainly of wrappers to standard third-party libraries.</p>
</li>
</ul>
<p><a name='what'></a></p>
<h2>Package repository</h2>
<ul>
<li>Package files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/aidesys'>https://gitlab.inria.fr/line/aide-group/aidesys</a></li>
<li>Package documentation: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidesys'>https://line.gitlabpages.inria.fr/aide-group/aidesys</a></li>
<li>Source files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/aidesys/-/tree/master/src'>https://gitlab.inria.fr/line/aide-group/aidesys/-/tree/master/src</a></li>
<li>Saved on <a target='_blank' href='https://archive.softwareheritage.org/browse/origin/directory/?origin_url=https://gitlab.inria.fr/line/aide-group/aidesys'>softwareherirage.org</a></li>
<li>Version <code>1.1.1</code></li>
<li>License <code>CECILL-C</code></li>
</ul>
<h2>Installation</h2>
<h3>User simple installation</h3>
<ul>
<li><code>npm install git+https://gitlab.inria.fr/line/aide-group/aidesys.git</code></li>
</ul>
<h3>Co-developper installation</h3>
<ul>
<li>See the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html#.install_as_developer'>related documentation</a></li>
</ul>
<p>Please refer to the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html'>installation guide</a> for installation.</p>
<p><a name='how'></a></p>
<h2>Usage</h2>
<h3>npm script usage</h3>
<pre class="prettyprint source"><code>npm install --quiet : installs all package dependencies and sources.
npm run build: builds the different compiled, documentation and test files.
npm test     : runs functional and non-regression tests.
npm run clean: cleans installation files.
</code></pre>
<p><a name='dep'></a></p>
<h2>Dependencies</h2>
<ul>
<li>None</li>
</ul>
<h2>devDependencies</h2>
<ul>
<li><tt>aidebuild: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild'>Builds multi-language compilation packages and related documentation.</a></tt></li>
</ul>
<p><a name='who'></a></p>
<h2>Author</h2>
<ul>
<li>Thierry Vieville <a href="mailto:thierry.vieville@inria.fr">thierry.vieville@inria.fr</a></li>
</ul></article>
    </section>






    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>